//---------------------------------------------------------------------------

#include <vcl.h>
#include <Winsock2.h>
#include <VideoIn.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
WSADATA wsaData;
MCTX ctx;
CVideoIn *vid = NULL;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  ::CoInitialize(NULL);
  ::WSAStartup(MAKEWORD(2, 0), &wsaData);

  Host->Items->Clear();
  GetIPAddresses();

  CDevice::GetSources(VideoDevices->Handle, 0);

  LoadCfg();
  if(VideoDevices->ItemIndex == -1)
  {
      StartButton->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GetIPAddresses()
{
  AnsiString ip;
  char name[MAX_PATH];
  memset(name, 0, MAX_PATH);
  gethostname(name, MAX_PATH);
  struct hostent *he = gethostbyname(name);
  if(he)
  {
    int i = 0;
    while(he->h_addr_list[i])
    {
      unsigned char *c = (unsigned char *)he->h_addr_list[i++];
      ip.printf("%u.%u.%u.%u", c[0], c[1], c[2], c[3]);
      Host->Items->Add(ip);
    }
    Host->ItemIndex = 0;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartButtonClick(TObject *Sender)
{
  if(!vid)
  {
    memset(&ctx, 0, sizeof(ctx));
    ctx.rate = Rate->Position;
    ctx.port = Port->Position;
    ctx.format = Format->ItemIndex;

    ctx.q = Quality->Position;
    ctx.gray = Gray->Checked;
    ctx.smooth = Smooting->Checked;

    _tcscpy(ctx.video, WideString(VideoDevices->Text).c_bstr());
    vid = new CVideoIn(&ctx);
    switch(vid->Run())
    {
      case 0:
        Status->Caption = "OK.";
        VideoButton->Enabled = true;
        SaveCfg();
        break;
      case 1:
        Status->Caption = "Cannot start the camera.";
        break;
      case 2:
        Status->Caption = "Network error. Cannot start server.";
        break;
    }
    StartButton->Caption = "&Stop";
  }
  else
  {
    vid->Exit();
    delete vid;
    vid = NULL;
    VideoButton->Enabled = false;
    StartButton->Caption = "&Start";
    Status->Caption = "";
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  ::WSACleanup();
  ::CoUninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image1Click(TObject *Sender)
{
  AnsiString cmd = "rundll32 url.dll,FileProtocolHandler " + Image1->Hint;
  ::WinExec(cmd.c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GrayClick(TObject *Sender)
{
  ctx.gray = Gray->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SmootingClick(TObject *Sender)
{
  ctx.smooth = Smooting->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::QualityChange(TObject *Sender)
{
  ctx.q = Quality->Position;
  Quality->Hint = IntToStr(ctx.q) + "%";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TestButtonClick(TObject *Sender)
{
  AnsiString cmd = "rundll32 url.dll,FileProtocolHandler http://" + Host->Text + ":" + Port->Position;
  ::WinExec(cmd.c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoButtonClick(TObject *Sender)
{
  if(vid)
  {
    vid->VideoProperty(this->Handle);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadCfg()
{
  TIniFile *cfg = new TIniFile(".\\ipcamera.cfg");
  VideoDevices->ItemIndex = cfg->ReadInteger("Init", "Camera", 0);
  Format->ItemIndex = cfg->ReadInteger("Init", "Format", 0);
  Rate->Position = cfg->ReadInteger("Init", "Rate", 5);
  Host->ItemIndex = cfg->ReadInteger("Init", "Host", 0);
  Port->Position = cfg->ReadInteger("Init", "Port", 8088);
  Quality->Position = cfg->ReadInteger("Init", "Quality", 75);
  Gray->Checked = cfg->ReadInteger("Init", "Gray", false);
  Smooting->Checked = cfg->ReadInteger("Init", "Smooting", false);
  delete cfg;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveCfg()
{
  TIniFile *cfg = new TIniFile(".\\ipcamera.cfg");
  cfg->WriteInteger("Init", "Camera", VideoDevices->ItemIndex);
  cfg->WriteInteger("Init", "Format", Format->ItemIndex);
  cfg->WriteInteger("Init", "Rate", Rate->Position);
  cfg->WriteInteger("Init", "Host", Host->ItemIndex);
  cfg->WriteInteger("Init", "Port", Port->Position);
  cfg->WriteInteger("Init", "Quality", Quality->Position);
  cfg->WriteInteger("Init", "Gray", Gray->Checked);
  cfg->WriteInteger("Init", "Smooting", Smooting->Checked);
  delete cfg;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MailToClick(TObject *Sender)
{
  AnsiString cmd = "rundll32 url.dll,FileProtocolHandler mailto:info@gmax.ws";
  ::WinExec(cmd.c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if(vid)
  {
    vid->Exit();
    delete vid;
    vid = NULL;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VideoDevicesChange(TObject *Sender)
{
  StartButton->Enabled = VideoDevices->ItemIndex >= 0;  
}
//---------------------------------------------------------------------------

