#include "Device.h"

void CDevice::GetSources(HWND hWnd, int kind)
{
  HRESULT hr;
  // Create the System Device Enumerator.
  ICreateDevEnum *pSysDevEnum;
  hr = CoCreateInstance(CLSID_SystemDeviceEnum,
    NULL, CLSCTX_INPROC_SERVER,
    IID_ICreateDevEnum,
    (void **)&pSysDevEnum);
  if(hr != S_OK)
  {
    return;
  }
  // Obtain a class enumerator for the video compressor category.
  IEnumMoniker *pEnumCat;
  hr = pSysDevEnum->CreateClassEnumerator((kind == 0) ?
    CLSID_VideoInputDeviceCategory : CLSID_AudioInputDeviceCategory,
    &pEnumCat, 0);
  if(hr != S_OK)
  {
    return;
  }
  // Enumerate the monikers.
  ULONG cFetched = 0;
  IPropertyBag *pPropBag = 0;
  IMoniker *pMoniker = 0;
  VARIANT varName;

  while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
  {
    if(pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag) == S_OK)
    {
      // To retrieve the friendly name of the filter, do the following:
      VariantInit(&varName);
      hr = pPropBag->Read(L"FriendlyName", &varName, 0);
      if(hr == S_OK)
      {
        ::SendMessageW(hWnd, CB_ADDSTRING, 0, (LONG)varName.bstrVal);
      }
      VariantClear(&varName);
      hr = pPropBag->Release();
    }
    hr = pMoniker->Release();
  }

  // clean up
  hr = pEnumCat->Release();
  hr = pSysDevEnum->Release();
}


