#include "Jpeg.h"

//---------------------------------------------------------------------------
CJpeg::CJpeg()
{
  Quality = 75;
  Smoothing = 0;
  Gray = FALSE;
}
//---------------------------------------------------------------------------
CJpeg::~CJpeg()
{
  if(memo.data)
  {
    free(memo.data);
  }
}
//---------------------------------------------------------------------------
void CJpeg::Compress(JSAMPLE *image_buffer, int Width, int Height)
{
  struct jpeg_compress_struct cinfo;
  struct jpeg_error_mgr jerr;
  cinfo.err = jpeg_std_error(&jerr);
  jpeg_create_compress(&cinfo);

  memo.data = NULL;
  memo.size = 0;
  jpeg_stdio_dest(&cinfo, &memo);

  cinfo.image_width = Width; 	/* image width and height, in pixels */
  cinfo.image_height = Height;
  cinfo.input_components = 3;	/* # of color components per pixel */
  cinfo.in_color_space = JCS_RGB; /* colorspace of input image */
  jpeg_set_defaults(&cinfo);

  jpeg_set_quality(&cinfo, Quality, TRUE);
  cinfo.smoothing_factor = Smoothing; //1..100;
  if(Gray == TRUE)
  {
    jpeg_set_colorspace(&cinfo, JCS_GRAYSCALE);
  }

  jpeg_start_compress(&cinfo, TRUE);
  JSAMPROW row_pointer[1];    /* pointer to a single row */
  int row_stride = cinfo.image_width * 3; /* JSAMPLEs per row in image_buffer */

  while (cinfo.next_scanline < cinfo.image_height)
  {
    row_pointer[0] = &image_buffer[(Height - cinfo.next_scanline - 1) * row_stride];
    jpeg_write_scanlines(&cinfo, row_pointer, 1);
  }

  jpeg_finish_compress(&cinfo);
  jpeg_destroy_compress(&cinfo);
}
//---------------------------------------------------------------------------
void CJpeg::SaveToFile(char *JFile)
{
  FILE *fp = fopen(JFile, "wb");
  if(!fp)
  {
    fwrite(memo.data, memo.size, 1, fp);
    fclose(fp);
  }
}
//---------------------------------------------------------------------------
