#ifndef VideoCaptureH
#define VideoCaptureH
/**
 * Video CVideoCapture.
 *
 * @author  Marius Gligor
 * @version 1.0 24.08.2006
 */ 
#include "Callback.h"
#include <Dvdmedia.h>
#include <tchar.h>

#ifndef SAFE_RELEASE

#define SAFE_RELEASE( x )  \
    if( NULL != x )        \
    {                      \
        x->Release( );     \
        x = NULL;          \
    }

#endif

class CVideoCapture : public CCallback
{
  HRESULT hr;
  // graph
  IGraphBuilder *pGraph;
  ICaptureGraphBuilder2 *pBuilder;
  IMediaControl *pControl;
  // filters
  IBaseFilter *pCaptureSource;
  IBaseFilter *pSampleGrabber;
  IBaseFilter *pRenderer;
  ISampleGrabber *pGrabber;
private:
  BOOL InitGraph();
  BOOL AddSource(LPTSTR bstrName);
  BOOL AddGrabber(CCallback *vid_call);
  BOOL AddRenderer();
  void WINAPI DeleteMediaType(AM_MEDIA_TYPE *pmt);
  void WINAPI FreeMediaType(AM_MEDIA_TYPE& mt);
public:
  BOOL SetFormat(int Width, int Height, int Rate);
  // ctor
  CVideoCapture();
  virtual ~CVideoCapture();
  BOOL Build(CCallback *vid_call, LPTSTR bstrName, int Width=320, int Height=240, int Rate=5);
  BOOL VideoProperty(HWND hWnd);
  BOOL Start();
  BOOL Stop();
};

#endif;