#include "VideoIn.h"

//---------------------------------------------------------------------------
CVideoIn::CVideoIn(MCTX *c) : CVideoCapture()
{
  ctx = c;
  ZeroMemory(&bio, sizeof(bio));
  bio.biSize = sizeof(bio);
  bio.biPlanes = 1;
  bio.biBitCount = 24;
  bio.biCompression = 0;
  switch(ctx->format)
  {
    case 0:
      bio.biWidth = 160;
      bio.biHeight = 120;
      break;
    case 1:
      bio.biWidth = 176;
      bio.biHeight = 144;
      break;
    case 2:
      bio.biWidth = 320;
      bio.biHeight = 240;
      break;
    case 3:
      bio.biWidth = 352;
      bio.biHeight = 288;
      break;
    case 4:
      bio.biWidth = 640;
      bio.biHeight = 480;
      break;
    case 5:
      bio.biWidth = 704;
      bio.biHeight = 576;
      break;
    case 6:
      bio.biWidth = 800;
      bio.biHeight = 600;
      break;
    case 7:
      bio.biWidth = 1024;
      bio.biHeight = 768;
      break;
    case 8:
      bio.biWidth = 1280;
      bio.biHeight = 720;
      break;
    case 9:
      bio.biWidth = 1280;
      bio.biHeight = 960;
      break;
    case 10:
      bio.biWidth = 1280;
      bio.biHeight = 1024;
      break;
    case 11:
      bio.biWidth = 1600;
      bio.biHeight = 1190;
      break;
    case 12:
      bio.biWidth = 1600;
      bio.biHeight = 1200;
      break;
    case 13:
      bio.biWidth = 1920;
      bio.biHeight = 1080;
      break;
  }
  bio.biSizeImage = bio.biWidth * bio.biHeight * 3;
}
//---------------------------------------------------------------------------
CVideoIn::~CVideoIn()
{
}
//---------------------------------------------------------------------------
int CVideoIn::Run()
{
  srv = new CServer(ctx->port);
  if(srv->connected)
  {
    if(Build(this, ctx->video, bio.biWidth, bio.biHeight, ctx->rate))
    {
      Start();
      return 0;
    }
    else
    {
      return 1;
    }
  }
  else
  {
    return 2;
  }
}
//---------------------------------------------------------------------------
void CVideoIn::Exit()
{
  // stop the graph
  Stop();
  // stop the server
  if(srv)
  {
    srv->StopThread();
    srv->Close();
    srv->WaitFor();
    delete srv;
    srv = NULL;
  }
}
//---------------------------------------------------------------------------
// 1
STDMETHODIMP CVideoIn::BufferCB(double Time, BYTE *pBuffer, long BufferLen)
{
  CJpeg *jpg = new CJpeg();
  if(jpg)
  {
    jpg->Gray = ctx->gray;
    jpg->Quality = ctx->q;
    jpg->Smoothing = ctx->smooth;
    jpg->Compress(pBuffer, bio.biWidth, bio.biHeight);
    srv->SendToAll(jpg->memo.data, jpg->memo.size);
    delete jpg;
  }
  return 0;
}
//---------------------------------------------------------------------------

