#include "Clients.h"

static char frame_hdr[128];
static char fmt[] = "--myboundary\r\nContent-Type: image/jpeg\r\nContent-Length: %u\r\n\r\n";
static char http_hdr[] = "HTTP/1.1 200 OK\r\nContent-Type: multipart/x-mixed-replace; boundary=--myboundary\r\n\r\n";

CClients::CClients() : CMonitor()
{
  list.clear();
}

CClients::~CClients()
{
  RemoveAll();
}

void CClients::Add(SOCKET cli)
{
  Lock();
  if(::send(cli, http_hdr, strlen(http_hdr), 0) != SOCKET_ERROR)
  {
    list.push_back(cli);
  }
  Unlock();
}

void CClients::RemoveAll()
{
  Lock();
  while(list.size())
  {
    SOCKET cli = *list.begin();
    list.erase(list.begin());
    ::shutdown(cli, SD_BOTH);
    ::closesocket(cli);
  }
  Unlock();
}

void CClients::SendBlock(unsigned char *buffer, int size)
{
  Lock();
  vector<SOCKET>::iterator c;
  for(c = list.begin();c != list.end();c++)
  {
    SOCKET cli = *c;
    if(SendFrame(cli, buffer, size) == SOCKET_ERROR)
    {
      ::shutdown(cli, SD_BOTH);
      ::closesocket(cli);
      c = list.erase(c);
      if(c == list.end())
      {
        break;
      }
    }
  }
  Unlock();
}

int CClients::SendFrame(SOCKET cli, void *buffer, int size)
{
  sprintf(frame_hdr, fmt, size);
  // send header
  int r = ::send(cli, frame_hdr, strlen(frame_hdr) , 0);
  if(r == SOCKET_ERROR)
  {
    return r;
  }
  // send picture
  r = ::send(cli, (char *)buffer, size, 0);
  if(r == SOCKET_ERROR)
  {
    return r;
  }
  // send end of frame
  r = ::send(cli, "\r\n", 2, 0);
  return r;
}

