#include "Server.h"

//---------------------------------------------------------------------------
CServer::CServer(int Port) : CThread()
{
  DWORD opt = 1;
  connected = 0;
  // create socket
  ss.sin_family = AF_INET;
  ss.sin_port = htons(Port);
  ss.sin_addr.s_addr = ADDR_ANY;
  srv = ::socket(AF_INET, SOCK_STREAM, 0);
  // start server
  if(srv != INVALID_SOCKET)
  {
    ::setsockopt(srv, IPPROTO_TCP, TCP_NODELAY, (const char*)&opt, sizeof(opt));
    ::setsockopt(srv, IPPROTO_TCP, SO_KEEPALIVE , (const char*)&opt, sizeof(opt));
    ::setsockopt(srv, IPPROTO_TCP, SO_REUSEADDR , (const char*)&opt, sizeof(opt));
    if(::bind(srv, (const sockaddr *)&ss, sizeof(ss)) == 0)
    {
      if(::listen(srv, SOMAXCONN) == 0)
      {
        connected = 1;
        StartThread();
      }
    }
  }
}
//---------------------------------------------------------------------------
CServer::~CServer()
{
}
//---------------------------------------------------------------------------
void __fastcall CServer::Close()
{
  // close server
  ::shutdown(srv, SD_BOTH);
  ::closesocket(srv);
}
//---------------------------------------------------------------------------
void CServer::Run()
{
  while(!Terminated(1000))
  {
    SOCKET cli = ::accept(srv, NULL, NULL);
    if(cli != INVALID_SOCKET)
    {
      conn.Add(cli);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall CServer::SendToAll(void *buffer, int size)
{
  conn.SendBlock((unsigned char *)buffer, size);
}
//---------------------------------------------------------------------------

