#include "Thread.h"

//-----------------------------------------------------------------------------
DWORD WINAPI CThread::ThreadProc(LPVOID lpThread)
{
  ((CThread *)lpThread)->Run();
  return 0;
}
//-----------------------------------------------------------------------------
CThread::CThread()
{
  // ctor
  hThread = NULL;
  hEvent = NULL;
  ThreadId = 0;
}
//-----------------------------------------------------------------------------
CThread::~CThread()
{
  // dtor
  if(hThread)
  {
    ::CloseHandle(hThread);
    hThread = NULL;
  }
  if(hEvent)
  {
    ::CloseHandle(hEvent);
    hEvent = NULL;
  }
}
//-----------------------------------------------------------------------------
BOOL CThread::StartThread(int Priority)
{
  // event
  hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
  if(!hEvent)
  {
    return FALSE;
  }
  ::ResetEvent(hEvent);
  // spawn a new thread
  hThread = ::CreateThread(NULL, 0, ThreadProc, this,
      CREATE_SUSPENDED, &ThreadId);
  if(!hThread)
  {
    return FALSE;
  }
  // set priority and run
  ::SetThreadPriority(hThread, Priority);
  ::ResumeThread(hThread);
  return TRUE;
}
//-----------------------------------------------------------------------------
void CThread::StopThread()
{
  ::SetEvent(hEvent);
}
//-----------------------------------------------------------------------------
void CThread::WaitFor(DWORD dwMilliseconds)
{
  ::WaitForSingleObject(hThread, dwMilliseconds);
}
//-----------------------------------------------------------------------------
BOOL CThread::Terminated(DWORD dwMilliseconds)
{
  return (::WaitForSingleObject(hEvent, dwMilliseconds) == WAIT_OBJECT_0);
}
//-----------------------------------------------------------------------------

